{********************************************************************************************
             Programa em Delphi para demonstrao da importao e utilizao da DLL
                                        SK_ACCESS
********************************************************************************************}

unit using_sk;

interface

uses
  //Messages, Graphics, Dialogs,
  Windows, SysUtils, Classes, Controls, Forms, StdCtrls;



type
   TForm1 = class(TForm)
      Button1: TButton;
      Button2: TButton;
      Button3: TButton;
      Button4: TButton;
      Button5: TButton;
      Button6: TButton;
      Button7: TButton;
      Button8: TButton;
      Button9: TButton;
      Button10: TButton;
      Button11: TButton;
      Button12: TButton;
      Button13: TButton;
      Button14: TButton;
      Button16: TButton;
      Button17: TButton;
      Button18: TButton;
      Button19: TButton;
      Button20: TButton;
      Button21: TButton;
      Button22: TButton;
      Button23: TButton;
      Edit1: TEdit;
      Edit2: TEdit;
      Edit3: TEdit;
      Edit4: TEdit;
      Edit5: TEdit;
      Edit6: TEdit;
      Edit7: TEdit;
      Edit8: TEdit;
      Label1: TLabel;
      Label2: TLabel;
      Label3: TLabel;
      procedure Button1Click(Sender: TObject);
      procedure Button2Click(Sender: TObject);
      procedure Button3Click(Sender: TObject);
      procedure Button4Click(Sender: TObject);
      procedure Button5Click(Sender: TObject);
      procedure Button6Click(Sender: TObject);
      procedure Button7Click(Sender: TObject);
      procedure Button8Click(Sender: TObject);
      procedure Button9Click(Sender: TObject);
      procedure Button10Click(Sender: TObject);
      procedure Button11Click(Sender: TObject);
      procedure Button12Click(Sender: TObject);
      procedure Button13Click(Sender: TObject);
      procedure Button14Click(Sender: TObject);
      procedure Button16Click(Sender: TObject);
      procedure Button17Click(Sender: TObject);
      procedure Button18Click(Sender: TObject);
      procedure Button19Click(Sender: TObject);               
      procedure Button20Click(Sender: TObject);
      procedure Button21Click(Sender: TObject);
      procedure Button22Click(Sender: TObject);
      procedure Button23Click(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure Edit6Enter(Sender: TObject);
      procedure Edit6Exit(Sender: TObject);
   end;

var
  Form1: TForm1;
  ctrl_8042:byte;
  pagina:byte;
  dll_ver:array[0..20] of char;

implementation

{$R *.DFM}
{******************************************************************************
             Declarao dos Procedimentos e Fuces da DLL
                             SK_ACCESS
******************************************************************************}
procedure Send_Data(data: byte); stdcall;
 external 'sk_access.dll' name 'Send_Data';

procedure Clear_Disp; stdcall;
 external 'sk_access.dll' name 'Clear_Disp';

procedure Clear_L1; stdcall;
 external 'sk_access.dll' name 'Clear_L1';

procedure Clear_L2; stdcall;
 external 'sk_access.dll' name 'Clear_L2';

procedure Cursor_Off; stdcall;
 external 'sk_access.dll' name 'Cursor_Off';

procedure Cursor_On; stdcall;
 external 'sk_access.dll' name 'Cursor_On';

procedure Cursor_Blink; stdcall;
 external 'sk_access.dll' name 'Cursor_Blink';

procedure Back_Space; stdcall;
 external 'sk_access.dll' name 'Back_Space';

procedure Line_Feed; stdcall;
 external 'sk_access.dll' name 'Line_Feed';

procedure Carriage_Return; stdcall;
 external 'sk_access.dll' name 'Carriage_Return';

procedure Gotoxy(x:byte ; y:byte); stdcall;
 external 'sk_access.dll' name 'Gotoxy';

procedure Disp_Char(data:char); stdcall;
 external 'sk_access.dll' name 'Disp_Char';

procedure Disp(data:PChar); stdcall;
 external 'sk_access.dll' name 'Disp';

function Get_Cursor(x:pointer;y:pointer):byte; stdcall;
 external 'sk_access.dll' name 'Get_Cursor';

function Get_Status:byte; stdcall;
 external 'sk_access.dll' name 'Get_Status';

procedure Set_Page1; stdcall;
 external 'sk_access.dll' name 'Set_Page1';

procedure Set_Page0; stdcall;
 external 'sk_access.dll' name 'Set_Page0';

procedure Free_Sk_Access; stdcall;
 external 'sk_access.dll' name 'Free_Sk_Access';

procedure Set_Eco_On; stdcall;
 external 'sk_access.dll' name 'Set_Eco_On';

procedure Set_Eco_Off; stdcall;
 external 'sk_access.dll' name 'Set_Eco_Off';

Procedure Set_Udg(caracter,def0,def1,def2,def3,def4,def5,def6,def7:byte); stdcall
 external 'sk_access.dll' name 'Set_Udg';

Function Set_Interface(interf:PChar):integer; stdcall;
 external 'sk_access.dll' name 'Set_Interface';

procedure Get_Dll_Version(data:PChar); stdcall;
 external 'sk_access.dll' name 'Get_Dll_Version';

procedure Reset_Interface; stdcall;
 external 'sk_access.dll' name 'Reset_Interface';

procedure Redirect; stdcall;
 external 'sk_access.dll' name 'Redirect';

function Get_Data_Rs(buffer:pointer;size:integer):integer; stdcall;
 external 'sk_access.dll' name 'Get_Data_Rs';
{******************************************************************************
        Boto Get Status:
        A funo Get_Status retorna 0  se teclado OK
                                    1  se tecaldo em FALHA
                                   255 se teclado no responde
******************************************************************************}

procedure TForm1.Button1Click(Sender: TObject);
var
   status:byte;
begin
   status:=Get_Status;
   if status=0 then edit5.text:='OK'
   else if status=1 then edit5.text:='FALHA'
   else edit5.text:='TIME-OUT';
end;
{******************************************************************************
       Boto Disp Str:
       Usa a Funo Disp para enviar uma string para o display do teclado
******************************************************************************}

procedure TForm1.Button2Click(Sender: TObject);
var
   strbuf:array[0..81] of char;
begin
   Disp(strpcopy(strbuf,edit4.text));
end;
{******************************************************************************
        Boto Clear Disp:
        Limpa o display do teclado e coloca o cursor em Home
******************************************************************************}

procedure TForm1.Button3Click(Sender: TObject);
begin
   Clear_Disp;
end;
{******************************************************************************
        Boto Clear L1:
        Apaga a linha superior do display do teclado
******************************************************************************}

procedure TForm1.Button4Click(Sender: TObject);
begin
   Clear_L1;
end;
{******************************************************************************
        Boto Clear L2:
        Apaga a linha inferior do display do teclado
******************************************************************************}

procedure TForm1.Button5Click(Sender: TObject);
begin
   Clear_L2;
end;
{******************************************************************************
        Boto Cursor On:
        Define o cursor como uma linha
******************************************************************************}

procedure TForm1.Button6Click(Sender: TObject);
begin
   Cursor_On;
end;
{******************************************************************************
        Boto Cursor Off:
        Apaga o cursor do display
******************************************************************************}

procedure TForm1.Button7Click(Sender: TObject);
begin
   Cursor_Off;
end;
{******************************************************************************
        Boto Cursor Blink:
        Define o cursor como um retngulo que pisca
******************************************************************************}

procedure TForm1.Button8Click(Sender: TObject);
begin
   Cursor_Blink;
end;
{******************************************************************************
        Boto Back Space:
        Executa um back space no display, arrasta o texto  direita
******************************************************************************}

procedure TForm1.Button9Click(Sender: TObject);
begin
   Back_Space;
end;
{******************************************************************************
        Boto Line Feed:
        Executa um line feed no display, se o cursor esta na primeira linha,
vai para a segunda, se esta na segunda, executa um scroll.
******************************************************************************}

procedure TForm1.Button10Click(Sender: TObject);
begin
   Line_Feed;
end;
{******************************************************************************
        Boto Carriage Ret.
        O cursor vai para o inicio da linha corrente
******************************************************************************}

procedure TForm1.Button11Click(Sender: TObject);
begin
   Carriage_Return;
end;
{******************************************************************************
        Boto Disp Char:
        Envia um caracter para o display do teclado
******************************************************************************}

procedure TForm1.Button12Click(Sender: TObject);
begin
   Disp_Char(Edit1.text[1]);
end;
{******************************************************************************
        Boto Gotoxy:
        Posiciona o cursor do display do teclado nas coordenadas XY fornecidas
        Home=(1,1)
******************************************************************************}

procedure TForm1.Button13Click(Sender: TObject);
var
   x,y,code:integer;
begin
   val(edit2.text,x,code);
   if code<>0 then begin
      edit2.text:='1';
      x:=1;
   end;

   val(edit3.text,y,code);
   if code<>0 then begin
      edit3.text:='1';
      y:=1;
   end;
   Gotoxy(x,y);
end;
{******************************************************************************
        Boto Get Cursor:
        Le as coordenadas atuais do cursor no display.
        Retorna o par (X,Y) com Home=(1,1)
        e retorna a posio incremental com:
        Home=0 e ltima posio do display=79
******************************************************************************}

procedure TForm1.Button14Click(Sender: TObject);
var
  d,x,y:byte;
  s:string[11];
  begin
     d:=Get_Cursor(@x,@y);  {Calcula X e Y}
     if d=$ff then edit5.text:='TIME-OUT'
     else begin
        str(x,s);
        edit2.text:=s; {Coordenada X 1..40}
        str(y,s);
        edit3.text:=s; {Coordenada y 1..2}
        str(d,s);
        edit5.text:=s; {Coordenada incremental 0..79}
     end;
  end;
{******************************************************************************
        Boto Troca Pagina:
        Chama alternadamente Set_Page0 e Set_Page1 para trocar a pagina de
scan code ativa do teclado.
******************************************************************************}

procedure TForm1.Button16Click(Sender: TObject);
begin
   if pagina=0 then begin
      pagina:=$01;
      Set_Page1;
   end else begin
      pagina:=$00;
      Set_Page0;
   end;
end;
{******************************************************************************
        Boto Limpa:
        Limpa o edit box do eco
******************************************************************************}

procedure TForm1.Button17Click(Sender: TObject);
begin
    Edit6.text:='';
end;
{******************************************************************************
        Boto Set_Udg:
        Usa o Procedimento Set_Udg (User Defined Graphics) repetidamente para
animar um desenho.
******************************************************************************}

procedure TForm1.Button18Click(Sender: TObject);
var
   car:byte;
begin
   cursor_off;
   disp_char(char($0));                         //Mostra o caracter #0
   for car:=0 to 4 do begin
     Set_Udg(0,$3F,$11,$11,$3F,$11,$11,$11,$00);//Redesenha o caracter #0
     sleep(100);
     Set_Udg(0,$11,$11,$3F,$11,$11,$11,$00,$3F);
     sleep(100);
     Set_Udg(0,$11,$3F,$11,$11,$11,$00,$3F,$11);
     sleep(100);
     Set_Udg(0,$3F,$11,$11,$11,$00,$3F,$11,$11);
     sleep(100);
     Set_Udg(0,$11,$11,$11,$00,$3F,$11,$11,$3F);
     sleep(100);
     Set_Udg(0,$11,$11,$00,$3F,$11,$11,$3F,$11);
     sleep(100);
     Set_Udg(0,$11,$00,$3F,$11,$11,$3F,$11,$11);
     sleep(100);
     Set_Udg(0,$00,$3F,$11,$11,$3F,$11,$11,$11);
     sleep(100);
   end;
   cursor_blink;
end;
{******************************************************************************
        Ao fechar o formulario, libera os recursor alocados pela DLL
******************************************************************************}

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Free_Sk_Access;
end;
{******************************************************************************
        Boto Get Ver:
        Le a verso da DLL
******************************************************************************}

procedure TForm1.Button19Click(Sender: TObject);
begin
   Get_Dll_Version(dll_ver);
   edit7.text:=dll_ver;
end;
{******************************************************************************
        Boto Set Interface:
        Set Interface, fora o tipo de comunicao usada(PS2,SERIAL,USB)
independentemente da deteco automtica
******************************************************************************}

procedure TForm1.Button20Click(Sender: TObject);
var
   strbuf:array[0..10] of char;
begin
   Set_Interface(strpcopy(strbuf,edit8.text));
end;
{******************************************************************************
        Boto Reset Inter.:
        A DLL Sk_Access executa uma busca para localizar a interface  qual o
teclado SMAK est conectado, aps ser encontrado a DLL se fixa nessa interface
e executa todas as comunicaes atravs dela. Reset_Interface desfaz essa
ligao, de forma que a DLL executar uma nova busca pelo teclado na prxima
comunicao.
******************************************************************************}

procedure TForm1.Button21Click(Sender: TObject);
begin
   Reset_Interface;
end;
{******************************************************************************
        Boto Redirect:
        Nos teclados seriais e USB programados nos modos(ps2_emul ou USB) o
Procedimento Redirect redireciona os dados recebidos do teclado serial para o
buffer de teclado padro, de forma que as teclas podem ser lidas pelas funes
de leitura de teclado padro de qualquer linguagem.
******************************************************************************}

procedure TForm1.Button22Click(Sender: TObject);
begin
   Redirect;
end;
{******************************************************************************
        Boto Get Rs:
        Le dados recebidos do teclado RS-232/USB.
******************************************************************************}

procedure TForm1.Button23Click(Sender: TObject);
var
   buffer:array[0..10] of char;
   c,d:byte;
begin
   c:=Get_Data_Rs(@buffer,3); //Le no maximo 3 dados e coloca no buffer
   if c>0 then                //Se tinha dados a serem lidos
      for d:=0 to c-1 do      //Coloca em Edit4
         edit4.text:=edit4.text+buffer[d];
end;
{******************************************************************************
        Janela de Eco entra em foco:
        Quando Edit6 (Janela do Eco)  ativada, o Eco da DLL  ativado tambm
e a DLL passa a enviar para o display do teclado os dados recebidos.
******************************************************************************}

procedure TForm1.Edit6Enter(Sender: TObject);
begin
   Set_Eco_On
end;
{******************************************************************************
        Janela de Eco sai de foco:
        Quando Edit6 (Janela do Eco)  desativada, a funo de Eco tambm .
******************************************************************************}

procedure TForm1.Edit6Exit(Sender: TObject);
begin
   Set_Eco_Off
end;

end.
